<template>
  <!--  TODO: Скорее всего это stateless component -->
  <!--  TODO: сделать emit clear с payload === props.id -->
  <Multiselect
    v-model="valueSelect"
    :class="addClasses"
    :track-by="trackBy"
    :label="label"
    :id="id"
    :placeholder="placeholder"
    :disabled="disabled"
    :options="disabled ? [] : options"
    :searchable="searchable"
    :allow-empty="allowEmpty"
    :show-labels="false"
    :multiple="isMultiple"
    :preselect-first="isPreselectFirst"
    :close-on-select="closeOnSelect"
    :max-height="maxHeight"
    @open="$emit('open')"
    @close="$emit('close')"
    @select="select">

    <!--Шаблон для стрелки, раскрывающей список-->
    <template
      slot="caret"
      slot-scope="{ toggle }">
      <span
        class="multiselect__select"
        @mousedown.prevent.stop="toggle()"
        v-show="!hasClearBtn">
        <img
          svg-inline
          src="~/assets/svg/redesign/select-arrow-down.svg">
      </span>
    </template>

    <template slot="noResult">Не найдено</template>

    <!-- Работает только для multiple="true"
    Шаблон для отображения в селекте количества выбранных элементов-->
    <template
      slot="selection"
      slot-scope="{ values, isOpen }">
      <span
        v-show="values.length && !isOpen"
        class="multiselect__single">
        <span v-if="values.length === 1">{{ values[0].id }}</span>
        <span v-else>{{ values.length }} выбрано</span>
      </span>
    </template>

    <!--Шаблон для элемента списка, когда список пуст-->
    <template slot="noOptions">Список пуст</template>

    <!--Шаблон для элемента списка - можно передать в slot произвольную разметку,
    по умолчанию просто выводится значение по ключу, указанному в track-by="name"-->
    <!--Для мультивыбора с галкой использовать такой шаблон слота:
    <template
      slot="option"
      slot-scope="{ option: { id, total } }">
      <div class="option__desc">
        <img
          svg-inline
          src="~/assets/svg/redesign/checked.svg">
        <span class="option__title">{{ id }}</span>
        <span class="option__small">{{ total | spacifyNumber }}</span>
      </div>
    </template>-->
    <template
      v-if="$scopedSlots && $scopedSlots.option"
      slot="option"
      slot-scope="{ option, search }">
      <slot
        name="option"
        :option="option"
        :search="search"/>
    </template>

    <!-- Шаблон для выбранного элемента -->
    <template
      slot="singleLabel"
      slot-scope="{ option, search }">
      <slot
        name="singleLabel"
        :option="option"
        :search="search"/>
    </template>

    <!--    TODO: Каким образом очищать поля-->
    <div
      slot="clear"
      v-show="hasClearBtn"
      class="multiselect__clear"
      @mousedown.prevent.stop="clear">
      <img
        svg-inline
        src="~/assets/svg/redesign/cross.svg">
    </div>
  </Multiselect>

  <!-- <div
    v-else
    class="multiselect multiselect--disabled"
    :class="addClasses">
    <span class="multiselect__select">
      <img
        svg-inline
        src="~/assets/svg/redesign/select-arrow-down.svg">
    </span>
    <div class="multiselect__tags">
      <span class="multiselect__placeholder">{{ placeholder }}</span>
    </div>
  </div> -->
</template>

<script>
import Multiselect from 'vue-multiselect';

export default {
  name: 'AppSelect',
  components: {
    Multiselect,
  },
  props: {
    id: {
      type: String,
      default: '',
    },
    classes: {
      type: Array,
      default() {
        return [];
      },
    },
    value: {
      type: [String, Object, Array],
      default() { return null; },
    },
    theme: {
      type: String,
      default: null,
    },
    isPreselectFirst: {
      type: Boolean,
      default: false,
    },
    placeholder: {
      type: String,
      default: 'Выберите',
    },
    isMultiple: {
      type: Boolean,
      default: false,
    },
    trackBy: {
      type: String,
      default: 'name',
    },
    label: {
      type: String,
      default: 'name',
    },
    maxHeight: {
      type: Number,
      default: 236,
    },
    options: {
      type: Array,
      default() {
        return [];
      },
    },
    searchable: {
      type: Boolean,
      default: true,
    },
    disabled: {
      type: Boolean,
      default: false,
    },
    hasClear: {
      type: Boolean,
      default: true,
    },
  },
  data() {
    return {};
  },
  computed: {
    closeOnSelect() {
      return !this.isMultiple;
    },
    allowEmpty() {
      return this.isMultiple;
    },
    addClasses() {
      const classes = [];
      this.theme === 'darker' && classes.push('multiselectThemeDarker');
      this.theme === 'small' && classes.push('multiselectThemeSmall');
      // TODO: ???
      classes.push(...this.classes);

      return classes;
    },
    valueSelect: {
      get() {
        return this.value;
      },
      set(option) {
        this.$emit('input', option || (this.isMultiple ? [] : null));
      },
    },
    hasClearBtn() {
      if (this.hasClear) {
        if (Array.isArray(this.valueSelect)) {
          return this.valueSelect.length;
        }
        return this.valueSelect;
      }

      return false;
    },
  },
  methods: {
    select(option = null, filterName) {
      this.$emit('select', option, filterName);
      this.$emit('searching', filterName);
    },
    clear() {
      this.valueSelect = this.isMultiple ? [] : null;
      this.$emit('clear');
    },
  },
};
</script>

<style lang="postcss">
  @import '~/assets/css/components/forms/select.css';
</style>
